
// (C) 2007-08 tomonaga tokuyama
// http://www.dropping.at

var inFront = true;
var front = null;
function load()
{
	setupParts();
	front = _gel("front");
	MyOverlay.setup(_gel("frontOverlay"), _gel("frontDropMe"));
	MyScalebar.setup(2.0, _gel("frontScalebarHitArea"), _gel("frontScalebarNob"), _gel("frontScaleGuide"));
	MyScalebarFit.setup(_gel("frontScalebarFit"));
	MyToolbar.setup(_gel("frontToolbar"));
	MyToolbarPreview.setup(_gel("frontToolbarPreview"));
	MyRotationHandle.setup(_gel("frontOverlayRotationHandle"), _gel("frontRotationGuide"));
	MyGuides.setup(_gel("frontGuides"));
	MyEffects.setup();
	MyBackWindow.setup();
	if (plugin)
		_log("plugin available");
	MyResizer.setup(_gel("frontResizeHandle"), new Position(128+38, 128+63), null, _gel("frontSizeGuide"),  _gel("frontSizeGuideW"),  _gel("frontSizeGuideH"));
	MyCanvas.setup(_gel("frontCanvas"), 19, 38, 19, 25);
    
	MyBackWindow.readPrefs();
    MyCanvas.loadImage(null);

	widget.setCloseBoxOffset(5, 20);
	document.addEventListener("keydown", keydown, true);
	resize();
}

function clearPrefs () {
	pref.set("filter", null);
	pref.set("fileType", null);
	pref.set("backdrop", null);
	pref.set("watermark", null);
	pref.set("enhance", null);
	pref.set("width", null);
	pref.set("height", null);
}


function remove()
{
	clearPrefs();
	if (plugin) {
		plugin.clearCaches();
		plugin.cleanUp();
	}
}


function hide()
{
    // Get all composition elements and pause or stop them
    var compositions = document.getElementsByTagName("embed");
    for (var f = 0; f < compositions.length; f++) {
        if (compositions[f].type == "application/x-quartzcomposer" &&
            !compositions[f].paused()) {
            if (attributes.pauseResume == 0) {
                compositions[f].pause();
            }
            else {
                compositions[f].stop();
            }
        }
    }
}


function show()
{
    // Get all composition elements and play them
    var compositions = document.getElementsByTagName("embed");
    for (var f = 0; f < compositions.length; f++) {
        if (compositions[f].type == "application/x-quartzcomposer" &&
            (!compositions[f].playing() || compositions[f].paused())) {
            compositions[f].play();
        }
    }
}

function sync()
{
}


function showBack(event)
{	
	MyBackWindow.updateValues();
	MyResizer.resizeToBack(showBack2);
	widget.setCloseBoxOffset(10, 10)	
}


function showBack2()
{
	inFront = false;

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}


function showFront(event)
{
	inFront = true;
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	
	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
//    setTimeout('MyCanvas.draw();', 1);
    setTimeout('MyBackWindow.applyChanges()',1);
    setTimeout('MyCanvas.synchronize()',750);
	setTimeout("MyResizer.resizeToFront()", 750);
	widget.setCloseBoxOffset(5, 20)	
}


if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}


function resize(event) 
{
	if (inFront) {
		front.style.height = window.innerHeight + "px";
		MyResizer.updateGuide();
		MyScalebar.updateNob();
		MyCanvas.resize()
	}
}


function mouseout(event) 
{
    if (MyCanvas.image)
        MyOverlay.fadeOut();
}


function mouseover(event) 
{
    if (MyCanvas.image)
        MyOverlay.fadeIn();
}


function drop(event) 
{
	_log("dropped");
	_log(event.dataTransfer.types);
	try {
		var filename = null;
		{
			var uri = event.dataTransfer.getData("text/uri-list");
			if (uri) {
				uri = uri.split("\n");
				uri = uri[0];		
				_log(uri);
				filename = plugin.readFile(uri);
			}
		}
		if (! filename) {
			var text = event.dataTransfer.getData("text/plain");
			if (text) {
				_log(text);
				filename = plugin.readText(text);
			}
		}

		if (filename) {
			MyCanvas.loadImage(filename);
		}
	} catch (ex) {
		if (_debugLevel)
			throw ex;
	}
}


function paste(event) 
{
	_log("pasted");
	if (!inFront)
		return;
		
	var filename = plugin.handlePaste();
	if (filename && MyCanvas.loadImage(filename)) {
		event.stopPropagation();
		event.preventDefault();
	}
}



function copy(event) 
{
	_log("copy");
	if (!inFront)
		return;
	if (! MyCanvas.image) {
		var filename = plugin.captureScreen(MyCanvas.left, MyCanvas.top, MyCanvas.right, MyCanvas.bottom);
		if (! filename)
			return;
		MyCanvas.setOffset(0, 0);
	}
	MyCanvas.applyChanges();
	plugin.handleCopy();	
	event.stopPropagation();
	event.preventDefault();
}

function cut(event) 
{
	_log("cut");
	if (!inFront)
		return;
	copy(event);
}


function dragenter(event) 
{
	event.stopPropagation();
	event.preventDefault();
}

function dragleave(event) 
{
	event.stopPropagation();
	event.preventDefault();
}

function dragover(event) 
{
	event.stopPropagation();
	event.preventDefault();
}


function keydown()
{
	if (! inFront)
		return;
	_log(event.keyCode)	
	if (event.keyCode == 13 || event.keyCode == 32) {
		_log("enter"); 
		MyToolbarPreview.click(null);
		event.keyCode = 0;		
		event.stopPropagation();
		event.preventDefault();
	}
	if (MyCanvas.image && (event.keyCode == 8 || event.keyCode == 46)) {
		MyCanvas.loadImage(null);
		plugin.doDelete();
        plugin.clearCaches();
		event.keyCode = 0;
		event.stopPropagation();
		event.preventDefault();
	}
}


function goDroppingInc(event) 
{
	widget.openURL("http://www.dropping.at/");
}

function loadFile(filename) {
	MyCanvas.loadImage(filename);
}

