
// (C) 2007-08 tomonaga tokuyama
// http://www.dropping.at

var MyCanvas = new Object();

MyCanvas.setup = function (element, left, top, right, bottom)
{
	this.element = element;
	this.left = left;
	this.top = top;
	this.right = right;
	this.bottom = bottom;
	//
    //this.bgElement = _gel("frontDefaultBG");
    this.imageURL = "";
	this.image = null;
	this.rotation = 0.0;
	this.scale = 1.0;
	this.offset = new Position(0.0, 0.0);
	this.clickPosition = null;
	this.dragOrigin = new Position(0,0);
	this.margin = new Position(this.left + this.right, this.top + this.bottom);	
	this.loadingAnimator = null;
	//
	this.BGType = null;
	//
	this.dropGuide = _gel("frontDropMe");
	//
	this.element.addEventListener("mousedown", this.mouseDown, true);
	this.element.addEventListener("dblclick", this.dblClick, false);
    
    //this.bgElement.style.backgroundImage = "";
    //this.bgElement.style.backgroundColor = "rgba(0.,0.,0.,0.1)";
};


MyCanvas.applyChanges = function () {
	var composition = this.element;
    var keys = composition.inputKeys();
    for (var k in keys) {
        k = keys[k];
        plugin.setAttribute(composition.getInputValue(k), k);
    }
	pos = this.getSize();
	plugin.setOutputSize(pos.x, pos.y);
	plugin.setAttribute(this.BGType, "_Background");
	plugin.setAttribute(this.effectName, "_FilterName");
    plugin.setFileType(MyBackWindow.outputFormatPopup.getValue());
}

MyCanvas.draw = function () {
    _log("mycanvas.draw was removed.");
}

MyCanvas.setEffect = function (effectName) {
    this.effectName = effectName;
    this.element.setInputValue("Filter_Location", (effectName ? "Effects/" + effectName + ".qtz" : ""));
	MyEffects.activate(effectName);
}

MyCanvas.synchronize = function ()
{
	var composition = this.element;
	if (composition.playing() == true)
	{
		composition.pause();
        composition.setInputValue("Image_Location", this.imageURL);
        this.setRotation(this.rotation);
        this.setScale(this.scale);
        this.setOffset(this.offset.x, this.offset.y);
        this.setBG(this.BGType);
        this.setEffect(this.effectName);
		composition.play();
	}
}

MyCanvas.resize = function () {
	this.element.style.left = this.left + 'px';
	this.element.style.top = this.top + 'px';
	this.element.style.width = window.innerWidth - this.margin.x + 'px';
	this.element.style.height = window.innerHeight - this.margin.y + 'px';
}

MyCanvas.setBG = function (type) {
	this.BGType = type;
	var composition = this.element;
    composition.setInputValue("Background_Location", "");
    if (type == "black") {
        composition.setInputValue("Background_Color", "black");
    } else if (type == "white") {
        composition.setInputValue("Background_Color", "white");
    } else if (type == "gray") {
        composition.setInputValue("Background_Color", "gray");
    } else if (type == "aqua") {
    } else { // trasnparent
        composition.setInputValue("Background_Location", "../Images/frontCanvasTransparentBG.png");
    }
}

MyCanvas.getSize = function (w, h) {
    if (! w) w = window.innerWidth;
    if (! h) h = window.innerHeight;
	return new Position(w - this.margin.x,
						h - this.margin.y);
}


MyCanvas.setOffset = function(x, y)
{
	this.offset.x = x;
	this.offset.y = y;
    this.element.setInputValue("Translation_X", x);
    this.element.setInputValue("Translation_Y", -y);
}

MyCanvas.setScale = function (value)
{
	this.scale = value;
    this.element.setInputValue("Scaling", this.scale);
	MyScalebar.updateNob();
}


MyCanvas.setRotation = function (value)
{
	this.rotation = value;
	MyRotationHandle.updateGuide();
    this.element.setInputValue("Rotation", -this.rotation / Math.PI * 180.);
}


MyCanvas.setDefaults = function (expand)
{
    _log('setDefaults');
}

MyCanvas.loadingAnimFunc = function (animation, now, first, done)
{
	var self = MyCanvas;
	self.setScale(now);
}

MyCanvas.loadingAnimEnd =  function ()
{
	delete MyCanvas.loadingAnimator;
}
MyCanvas.startLoadingAnim =  function (finishScale)
{
	if(this.loadingAnimator) {
		this.loadingAnimator.stop();
		delete this.loadingAnimator;
	}
	this.loadingAnimator = new AppleAnimator (250, 13);
	this.loadingAnimator.oncomplete = this.endFade;
	this.loadingAnimator.addAnimation(new AppleAnimation (0.0, finishScale, this.loadingAnimFunc));
	this.loadingAnimator.start();
}


MyCanvas.loadImage = function (filename)
{
	_log("load image: " + filename);
    // plugin.clearCaches();
    this.image = null;
    if (! filename) {
        this.element.setInputValue("Image_Location", '');
        this.element.style.visibility = "hidden";
        this.dropGuide.style.display = "block";
        MyResizer.restoreDefault();
        MyGuides.hide();
        MyOverlay.fadeOut();
        //this.bgElement.style.display = "block";
        return false;
    }
    
    this.imageURL = filename;
	filename = filename + ("?" + (new Date).getTime());
	var image = new Image();
	image.src = filename;
	if (! image) {
        return false;
    }
	image.onload = function () {MyCanvas.setImage(image);}
	if (image.complete) image.onload();
	return true;
}

MyCanvas.setImage = function (image)
{
	this.image = image;
    this.setScale(0.0);
    this.element.style.visibility = "visible";
    this.element.setInputValue("Image_Location", this.imageURL);
	this.dropGuide.style.display = "none";
    //this.bgElement.style.display = "none";
    MyOverlay.fadeIn();
	var pos = MyCanvas.getSize(MyResizer.editingRect.right, MyResizer.editingRect.bottom);
	var expand = true;
	var newScale;
	if (this.image) {
		newScale = _max(pos.x / this.image.width,
			            pos.y / this.image.height);
		if (! expand)
			newScale = _min(1.0, newScale);
	} else {
		newScale = 1.0;
	}
	this.setOffset(0,0);
	this.setRotation(0);
    if (! MyResizer.inDefault)
        this.startLoadingAnim(newScale);
    else {
        this.setScale(newScale);
        MyResizer.restoreEditingRect();
    }
}

MyCanvas.endFade =  function ()
{
	delete this.fadeAnimator;
	delete this.fadeAnimation;
}

MyCanvas.mouseDown = function (event)
{
	var self = MyCanvas;
	self.dragOrigin.set(self.offset);
	self.clickPosition = self.offset.sub(event);
	document.addEventListener("mousemove", self.mouseMove, true);
    document.addEventListener("mouseup", self.mouseUp, true);
	event.stopPropagation();
	event.preventDefault();
}

MyCanvas.mouseMove = function (event)
{
	MyGuides.show();
	var self = MyCanvas;
	var newPos = self.clickPosition.add(event);
	if (event.shiftKey) {
		var dx = Math.abs(newPos.x - self.dragOrigin.x);
		var dy = Math.abs(newPos.y - self.dragOrigin.y);
		if (dx > dy)
			newPos.y = self.dragOrigin.y;
		else if (dx < dy)
			newPos.x = self.dragOrigin.x;
	}
	self.offset.set(newPos);
    self.setOffset(self.offset.x, self.offset.y);
	event.stopPropagation();
	event.preventDefault();
}


MyCanvas.mouseUp = function (event)
{
	var self = MyCanvas;
    document.removeEventListener("mousemove", self.mouseMove, true);
    document.removeEventListener("mouseup", self.mouseUp, true); 
	MyGuides.hide();
	event.stopPropagation();
	event.preventDefault();
}


MyCanvas.dblClick = function (event)
{
	var self = MyCanvas;
	self.setOffset(0,0);
}

