
_debugLevel = 0;

function _gel(id) {
	return document.getElementById(id);
}

function _log(s) {
	if (_debugLevel > 0)
		alert(s);
}

function _max(x, y) {
	return (x > y ? x : y);
}

function _min(x, y) {
	return (x < y ? x : y);
}


function toggleCheckbox(event)
{
	var checkbox = event.srcElement.parentElement.children[0];
	checkbox.checked = ! checkbox.checked;
}

var Position = function (x,y) { this.x = x; this.y = y;}
Position.prototype = {
set : function (pos) { this.x = pos.x; this.y = pos.y;},
add : function (pos) { return new Position(this.x+pos.x, this.y+pos.y);},
sub : function (pos) { return new Position(this.x-pos.x, this.y-pos.y);},
equal : function (pos) { return (this.x==pos.x) && (this.y==pos.y); },
toString : function () { return "["+this.x+","+this.y+"]";}
}

function MyPopup(element)
{
	this.element = element;
};

MyPopup.prototype = {

	init : function (caption, list) {
		this.element.options = null;
		if (caption) {
			var optgrp = document.createElement("optgroup");
			optgrp.label = caption;
			
			for (var i=0; i<list.length; i++) {
				var opt = document.createElement("option");
				opt.text = list[i].txt;
				opt.value = list[i].val;
				optgrp.appendChild(opt);
			}
			this.element.appendChild(optgrp);
		} else {
			for (var i=0; i<list.length; i++) {
				this.element.options[i] = new Option(list[i].txt, list[i].val, 0);
			}
		}
	},

	getValue : function()
	{
		return this.element.options[this.element.selectedIndex].value;
	},
	
	setValue : function (value)
	{
		for (var i=0; i<this.element.options.length; i++) {
			if (this.element.options[i].value == value) {
				this.element.selectedIndex = i;
				return;
			}				
		}
	}
}


var pref = new Object();

pref.createKey = function (key) {
	if (window.widget)
		return widget.identifier + "-" + key;
	else
		return key;
}

pref.get = function (key, def) {
	if (window.widget) {
		var k = this.createKey(key);
		if (widget.preferenceForKey(k) != null)
			return widget.preferenceForKey(k);
	}
	return def;
}

pref.set = function (key, val) {
	if (window.widget)
		widget.setPreferenceForKey(val, this.createKey(key));
}

