
// (C) 2007-08 tomonaga tokuyama
// http://www.dropping.at


var MyResizer = new Object;

MyResizer.setup = function (element, min /*Position*/, max/*Position*/, guideElement, guideElementW, guideElementH) {
	this.element = element;
	this.min = min;
	this.max = max;
	this.clickPosition = null;
	this.frontRect = null;
	this.guideElement = guideElement;
	this.guideElementH = guideElementH;
	this.guideElementW = guideElementW;
	this.endAnimCallback = null;
	this.element.addEventListener("mousedown", this.mouseDown, true);
	this.element.addEventListener("dblclick", this.dblClick, false);
	this.backRect = new AppleRect(0, 0, window.innerWidth, window.innerHeight);
	this.kSnap = 10;
    this.editingRect =  new AppleRect(0, 0, 400, 300);
    this.inDefault = false;
	var w = window.innerWidth;
	var h = window.innerHeight;
	var v;
	if (v = pref.get("width", null))
		w = v;
	if (v = pref.get("height", null))
		h = v;
    if (w && h)
        this.setEditingRect(new AppleRect(0., 0., w, h));
    else {
        _log("default rect");
        this.restoreDefault();
    }
};

MyResizer.setEditingRect = function (rect) {
    this.editingRect = rect;
	pref.set("width", rect.right);
	pref.set("height", rect.bottom);
    if (MyCanvas.image) {
        window.resizeTo(rect.w, rect.h);
    }
}

MyResizer.updateGuide = function () {
	var pos = MyCanvas.getSize();
	this.guideElementW.innerHTML = pos.x + "px";
	this.guideElementH.innerHTML = pos.y + "px";
}


MyResizer.mouseDown = function (event)
{
    if (! MyCanvas.image) return;
	var self = MyResizer;
	document.addEventListener("mousemove", self.mouseMove, true);
    document.addEventListener("mouseup", self.mouseUp, true);
	self.clickPosition = new Position((window.innerWidth - event.x), 
									  (window.innerHeight - event.y));
	self.updateGuide();
	event.stopPropagation();
	event.preventDefault();
};


MyResizer.mouseMove = function (event)
{
	if((event.x == -1 ) ) { break; }
	MyGuides.show();

	var self = MyResizer;
	var newPos = self.clickPosition.add(event);
	if (event.shiftKey) {
		newPos = newPos.sub(MyCanvas.margin);
		newPos.x = self.kSnap * Math.round(newPos.x / self.kSnap);	
		newPos.y = self.kSnap * Math.round(newPos.y / self.kSnap);			
		newPos = newPos.add(MyCanvas.margin);
	}
	if (self.min) {
		if(newPos.x < self.min.x)
			newPos.x = self.min.x;
		if(newPos.y < self.min.y)
			newPos.y = self.min.y;
	}
	if (self.max) {
		if(newPos.x > self.max.x)
			newPos.x = self.max.x;
		if(newPos.y > self.max.y)
			newPos.y = self.max.y;
	}
    window.resizeTo(newPos.x, newPos.y);
    event.stopPropagation();
    event.preventDefault();
};


MyResizer.mouseUp = function (event)
{
	var self = MyResizer;
    document.removeEventListener("mousemove", self.mouseMove, true);
    document.removeEventListener("mouseup", self.mouseUp, true); 
	MyGuides.hide();
    self.setEditingRect(new AppleRect(0, 0, window.innerWidth, window.innerHeight));
	event.stopPropagation();
    event.preventDefault();
};

MyResizer.dblClick = function (event)
{
	var self = MyResizer;
	if (! MyCanvas.image)
		return;
	var w = MyCanvas.image.width * MyCanvas.scale + MyCanvas.margin.x;
	var h = MyCanvas.image.height * MyCanvas.scale + MyCanvas.margin.y;
	
	if (self.min) {
		if(w < self.min.x)
			w = self.min.x;
		if(h < self.min.y)
			h = self.min.y;
	}
	if (self.max) {
		if(w > self.max.x)
			w = self.max.x;
		if(h > self.max.y)
			h = self.max.y;
	}	
    window.resizeTo(w,h);
	pref.set("width", window.innerWidth);
	pref.set("height", window.innerHeight);
};

MyResizer.restoreEditingRect = function () {
    this.resizeUsingAnim(null, MyResizer.editingRect, null);
    this.inDefault = false;
}

MyResizer.restoreDefault = function () {
//    MyResizer.resizeUsingAnim(null, new AppleRect(0, 0, MyResizer.min.x+32., MyResizer.min.y+32), null);
    MyResizer.resizeUsingAnim(null, new AppleRect(0, 0, 305,261), null);
    MyResizer.inDefault = true;
}

MyResizer.resizeAnim = function ( rectAnimation, currentRect, startingRect, finishingRect )
{
	window.resizeTo(currentRect.right, currentRect.bottom);
}


MyResizer.endAnim = function ()
{
	var self = MyResizer;
    if (MyCanvas.image)
    	MyGuides.hide();
	if (self.endAnimCallback)
		self.endAnimCallback();
}


MyResizer.resizeUsingAnim = function (startingRect, finishingRect, callback)
{
    if (MyCanvas.image)
        MyGuides.show();
	this.endAnimCallback = callback;
    if (! startingRect) startingRect = new AppleRect (0, 0, window.innerWidth, window.innerHeight);
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, this.resizeAnim);
	var currentAnimator = new AppleAnimator (500, 13);
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.oncomplete = this.endAnim;
	currentAnimator.start();	
}

MyResizer.resizeToFront = function ()
{
    this.resizeUsingAnim(this.backRect, this.frontRect, null);
}


MyResizer.resizeToBack = function (callback)
{
	this.frontRect = new AppleRect (0, 0, window.innerWidth, window.innerHeight); // save current
    this.resizeUsingAnim(this.frontRect, this.backRect, callback);
}




