
// (C) 2007-08 tomonaga tokuyama
// http://www.dropping.at


var MyRotationHandle = new Object();

MyRotationHandle.setup = function (element, guideElement)
{
	this.element = element;
	this.guideElement = guideElement;
	this.element.addEventListener("mousedown", this.mouseDown, true);
	this.element.addEventListener("dblclick", this.dblClick, false);
	this.startRad = 0.0;
	this.kSnap = Math.PI  / 180.0 * (15.0);
}


MyRotationHandle.updateGuide = function ()
{
	this.guideElement.innerHTML = Math.round(MyCanvas.rotation / Math.PI * 180) + "º";
}


MyRotationHandle.mouseDown = function (event)
{
	var self = MyRotationHandle;
	var x = event.x - window.innerWidth / 2.0;
    var y = event.y - window.innerHeight / 2.0;
	self.startRad = - MyCanvas.rotation + Math.atan2(y, x);
	document.addEventListener("mousemove", self.mouseMove, true);
    document.addEventListener("mouseup", self.mouseUp, true);
	event.stopPropagation();
	event.preventDefault();
};


MyRotationHandle.mouseMove = function (event)
{
	MyGuides.show();
	var self = MyRotationHandle;
	if((event.x == -1 ) ) { return; }
	var x = event.x - window.innerWidth / 2.0;
    var y = event.y - window.innerHeight / 2.0;
	var rad = Math.atan2(y, x) - self.startRad;
	if (event.shiftKey) {
		rad = self.kSnap * Math.round(rad / self.kSnap);	
	}
	MyCanvas.setRotation(rad);
	event.stopPropagation();
	event.preventDefault();
};


MyRotationHandle.mouseUp = function (event)
{
	var self = MyRotationHandle;
    document.removeEventListener("mousemove", self.mouseMove, true);
    document.removeEventListener("mouseup", self.mouseUp, true); 
	MyGuides.hide();
	event.stopPropagation();
	event.preventDefault();
};


MyRotationHandle.dblClick = function (event)
{
	MyCanvas.setRotation(0.);
};
