
// (C) 2007-08 tomonaga tokuyama
// http://www.dropping.at

MyScalebar = new Object();

MyScalebar.setup = function (scale, element, nobElement, guideElement)
{
	this.element = element;
	this.nobElement = nobElement;
	this.scale = scale;
	this.clickOffset = this.element.offsetLeft;
	this.margin = window.innerWidth - this.element.offsetWidth;
	this.nobOffset = this.element.offsetLeft - this.nobElement.offsetWidth / 2.0;
	this.guideElement = guideElement;
	this.guideOffset = this.element.offsetLeft - this.guideElement.offsetWidth / 2.0;
	this.element.addEventListener("mousedown", this.mouseDown, true);
	this.element.addEventListener("dblclick", this.dblClick, false);
	this.updateNob();
};

MyScalebar.handleMouseEvent = function (event)
{
	var snap = this.element.offsetWidth / this.scale;
	var x = (event.x - this.clickOffset);
	if (Math.abs(snap - x) < 3)
		x = snap;
	var ratio =  x / this.element.offsetWidth;
	if (ratio < 0) ratio = 0;
	if (ratio > 1) ratio = 1;
	MyCanvas.setScale(ratio * this.scale);
	event.stopPropagation();
	event.preventDefault();
}

MyScalebar.mouseDown = function (event)
{
	var self = MyScalebar;
	document.addEventListener("mousemove", self.mouseMove, true);
    document.addEventListener("mouseup", self.mouseUp, true);
	self.handleMouseEvent(event);
};



MyScalebar.updateNob = function ()
{
	var left = (window.innerWidth - this.margin) * _min(MyCanvas.scale, this.scale) / this.scale;
	this.nobElement.style.left = this.nobOffset + left+ "px";
	this.guideElement.style.left = this.guideOffset + left + "px";
	this.guideElement.innerHTML =  Math.round(MyCanvas.scale * 100) + "%";
}


MyScalebar.mouseMove = function (event)
{
	MyGuides.show();
	MyScalebar.handleMouseEvent(event);
}


MyScalebar.mouseUp = function (event)
{
	var self = MyScalebar;
    document.removeEventListener("mousemove", self.mouseMove, true);
    document.removeEventListener("mouseup", self.mouseUp, true); 
	MyGuides.hide();
	event.stopPropagation();
	event.preventDefault();
};


MyScalebar.dblClick = function (event)
{
	MyCanvas.setScale(1.0);
};


var MyScalebarFit = new Object();
MyScalebarFit.setup = function (element) {
	element.addEventListener("click", this.click, false);
}


MyScalebarFit.click = function (event)
{
	MyCanvas.setDefaults(true);
}


var MyScalebarReset = new Object();
MyScalebarReset.setup = function (element) {
	element.addEventListener("click", this.click, false);
}


MyScalebarReset.click = function (event)
{
	MyCanvas.setScale(1.0);
	MyCanvas.setRotation(0);
}






